package kaysaar.aotd_question_of_loyalty.data.intel;

import com.fs.starfarer.api.ui.EventProgressBarAPI;
import java.util.Collections;
import com.fs.starfarer.api.ui.UIComponentAPI;
import com.fs.starfarer.api.ui.CustomPanelAPI;
import com.fs.starfarer.api.campaign.BattleAPI;
import kaysaar.aotd_question_of_loyalty.data.intel.secession.EmergentAuthorityApplier;
import com.fs.starfarer.api.campaign.ReputationActionResponsePlugin;
import com.fs.starfarer.api.impl.campaign.intel.FactionCommissionIntel;
import com.fs.starfarer.api.campaign.comm.CommMessageAPI;
import com.fs.starfarer.api.impl.campaign.CoreReputationPlugin;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import exerelin.campaign.diplomacy.DiplomacyBrain;
import com.fs.starfarer.api.campaign.RepLevel;
import exerelin.campaign.DiplomacyManager;
import com.fs.starfarer.api.campaign.CampaignEventListener;
import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.impl.campaign.intel.events.EventFactor;
import kaysaar.aotd_question_of_loyalty.data.intel.secession.eventfactors.HoldoutEventFactor;
import com.fs.starfarer.api.ui.Alignment;
import java.awt.Color;
import com.fs.starfarer.api.ui.TooltipMakerAPI;
import com.fs.starfarer.api.campaign.comm.IntelInfoPlugin;
import java.util.Collection;
import java.util.List;
import kaysaar.aotd_question_of_loyalty.data.intel.secession.AoTDSecessionFleetIntel;
import org.lazywizard.lazylib.MathUtils;
import com.fs.starfarer.api.util.Misc;
import java.util.Iterator;
import com.fs.starfarer.api.Global;
import java.util.LinkedHashMap;
import com.fs.starfarer.api.campaign.econ.MarketAPI;
import java.util.ArrayList;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.listeners.FleetEventListener;
import com.fs.starfarer.api.impl.campaign.intel.events.BaseEventIntel;

public class AoTDSecessionManager extends BaseEventIntel implements FleetEventListener
{
    public static String memFlag;
    public FactionAPI rebellingAgainst;
    public ArrayList<MarketAPI> originalMarkets;
    public ArrayList<MarketAPI> marketsCaptured;
    public float fleetsDefeatedSince;
    public LinkedHashMap<Stage, ArrayList<AoTDExpeditionData>> dataOfExpeditions;
    
    public static AoTDSecessionManager get() {
        return (AoTDSecessionManager)Global.getSector().getMemory().get(AoTDSecessionManager.memFlag);
    }
    
    public int getMarketsStillOwned() {
        int ow = 0;
        for (final MarketAPI originalMarket : this.originalMarkets) {
            if (originalMarket.getFaction().isPlayerFaction()) {
                ++ow;
            }
        }
        return ow;
    }
    
    public ArrayList<MarketAPI> getOriginalMarkets() {
        return this.originalMarkets;
    }
    
    protected void notifyStageReached(final BaseEventIntel.EventStageData stage) {
        final Stage stg = this.getStage(stage.id);
        if (stg == Stage.THRESHOLD_1) {
            if (this.dataOfExpeditions == null) {
                this.dataOfExpeditions = new LinkedHashMap<Stage, ArrayList<AoTDExpeditionData>>();
            }
            final ArrayList<AoTDExpeditionData> data = new ArrayList<AoTDExpeditionData>();
            for (final MarketAPI playerMarket : Misc.getPlayerMarkets(false)) {
                final float fp = (float)MathUtils.getRandomNumberInRange(90, 120);
                final AoTDSecessionFleetIntel intel = new AoTDSecessionFleetIntel(this.rebellingAgainst, (MarketAPI)Misc.getFactionMarkets(this.rebellingAgainst).get(0), playerMarket, fp, (float)MathUtils.getRandomNumberInRange(10, 15), AoTDSecessionGoal.RETAKE, new AoTDSecessionReason(AoTDSecessionGoal.RETAKE));
                data.add(new AoTDExpeditionData(playerMarket, intel));
            }
            for (final MarketAPI playerMarket : this.marketsCaptured) {
                if (!playerMarket.isPlayerOwned()) {
                    continue;
                }
                final float fp = (float)MathUtils.getRandomNumberInRange(120, 150);
                final AoTDSecessionFleetIntel intel = new AoTDSecessionFleetIntel(this.rebellingAgainst, (MarketAPI)Misc.getFactionMarkets(this.rebellingAgainst).get(0), playerMarket, fp, (float)MathUtils.getRandomNumberInRange(10, 15), AoTDSecessionGoal.RETAKE, new AoTDSecessionReason(AoTDSecessionGoal.RETAKE));
                data.add(new AoTDExpeditionData(playerMarket, intel));
            }
            this.dataOfExpeditions.put(stg, data);
        }
        if (stg == Stage.THRESHOLD_2) {
            if (this.dataOfExpeditions == null) {
                this.dataOfExpeditions = new LinkedHashMap<Stage, ArrayList<AoTDExpeditionData>>();
            }
            final ArrayList<AoTDExpeditionData> data = new ArrayList<AoTDExpeditionData>();
            for (final MarketAPI playerMarket : Misc.getPlayerMarkets(false)) {
                final float fp = (float)MathUtils.getRandomNumberInRange(140, 180);
                final AoTDSecessionFleetIntel intel = new AoTDSecessionFleetIntel(this.rebellingAgainst, (MarketAPI)Misc.getFactionMarkets(this.rebellingAgainst).get(0), playerMarket, fp, (float)MathUtils.getRandomNumberInRange(10, 15), AoTDSecessionGoal.RETAKE, new AoTDSecessionReason(AoTDSecessionGoal.RETAKE));
                data.add(new AoTDExpeditionData(playerMarket, intel));
            }
            for (final MarketAPI playerMarket : this.marketsCaptured) {
                if (!playerMarket.isPlayerOwned()) {
                    continue;
                }
                final float fp = (float)MathUtils.getRandomNumberInRange(200, 250);
                final AoTDSecessionFleetIntel intel = new AoTDSecessionFleetIntel(this.rebellingAgainst, (MarketAPI)Misc.getFactionMarkets(this.rebellingAgainst).get(0), playerMarket, fp, (float)MathUtils.getRandomNumberInRange(10, 15), AoTDSecessionGoal.RETAKE, new AoTDSecessionReason(AoTDSecessionGoal.RETAKE));
                data.add(new AoTDExpeditionData(playerMarket, intel));
            }
            this.dataOfExpeditions.put(stg, data);
        }
        if (stg == Stage.THRESHOLD_3) {
            if (this.dataOfExpeditions == null) {
                this.dataOfExpeditions = new LinkedHashMap<Stage, ArrayList<AoTDExpeditionData>>();
            }
            final ArrayList<AoTDExpeditionData> data = new ArrayList<AoTDExpeditionData>();
            for (final MarketAPI playerMarket : Misc.getPlayerMarkets(false)) {
                final float fp = (float)MathUtils.getRandomNumberInRange(250, 270);
                final AoTDSecessionFleetIntel intel = new AoTDSecessionFleetIntel(this.rebellingAgainst, (MarketAPI)Misc.getFactionMarkets(this.rebellingAgainst).get(0), playerMarket, fp, (float)MathUtils.getRandomNumberInRange(10, 15), AoTDSecessionGoal.BOMBARD, new AoTDSecessionReason(AoTDSecessionGoal.RETAKE));
                data.add(new AoTDExpeditionData(playerMarket, intel));
            }
            for (final MarketAPI playerMarket : this.marketsCaptured) {
                if (!playerMarket.isPlayerOwned()) {
                    continue;
                }
                final float fp = (float)MathUtils.getRandomNumberInRange(250, 280);
                final AoTDSecessionFleetIntel intel = new AoTDSecessionFleetIntel(this.rebellingAgainst, (MarketAPI)Misc.getFactionMarkets(this.rebellingAgainst).get(0), playerMarket, fp, (float)MathUtils.getRandomNumberInRange(10, 15), AoTDSecessionGoal.RETAKE, new AoTDSecessionReason(AoTDSecessionGoal.RETAKE));
                data.add(new AoTDExpeditionData(playerMarket, intel));
            }
            this.dataOfExpeditions.put(stg, data);
        }
    }
    
    public AoTDSecessionManager(final List<MarketAPI> startingMarkets, final FactionAPI rebellingAgainst) {
        this.originalMarkets = new ArrayList<MarketAPI>();
        this.marketsCaptured = new ArrayList<MarketAPI>();
        this.dataOfExpeditions = new LinkedHashMap<Stage, ArrayList<AoTDExpeditionData>>();
        this.originalMarkets = new ArrayList<MarketAPI>(startingMarkets);
        this.rebellingAgainst = rebellingAgainst;
        this.setUp();
        Global.getSector().getMemory().set(AoTDSecessionManager.memFlag, (Object)this);
        Global.getSector().getIntelManager().addIntel((IntelInfoPlugin)this);
    }
    
    public void addStageDescriptionWithImage(final TooltipMakerAPI main, final Object stageId) {
        super.addStageDescriptionWithImage(main, stageId);
    }
    
    public void addStageDescriptionText(final TooltipMakerAPI info, final float width, final Object stageId) {
        final float opad = 10.0f;
        final float small = 0.0f;
        final Color h = Misc.getHighlightColor();
        final BaseEventIntel.EventStageData stage = this.getDataFor(stageId);
        if (stage == null) {
            return;
        }
        if (this.isStageActive(stageId)) {
            this.addStageDesc(info, this.getStage(stageId), small, false);
        }
    }
    
    public void addStageDesc(final TooltipMakerAPI info, final Stage stageId, final float initPad, final boolean forTooltip) {
        if (stageId == Stage.START) {
            info.addPara("We have started our fight against our masters. At this stage they are in shock  of our treason, but this will not last. We must move quickly", 5.0f);
        }
        if (stageId == Stage.THRESHOLD_1) {
            info.addPara("Internal security and local defensive forces are scrambling to deal with our worlds. They are fully equipped and have standing orders to take our planets. Protect our people.", 5.0f);
            info.addSectionHeading("Current markets", Alignment.MID, 5.0f);
            this.generateTooltipForMarkets(info, stageId);
        }
        if (stageId == Stage.THRESHOLD_2) {
            info.addPara("A massive armada has been assembled to conquer our worlds. We must bolster our defences!", 5.0f);
            info.addSectionHeading("Current markets", Alignment.MID, 5.0f);
            this.generateTooltipForMarkets(info, stageId);
        }
        if (stageId == Stage.THRESHOLD_3) {
            info.addPara("The military itself has mobilized to a total war standing against us. They no longer consider us as insignificant rebellion, they have been fully authorized to raze our worlds!", 5.0f);
            info.addSectionHeading("Current markets", Alignment.MID, 5.0f);
            this.generateTooltipForMarkets(info, stageId);
            info.addPara("This is their final attempt to put rebellion down. If we manage to defeat all fleets , we will gain independence!", 5.0f);
        }
    }
    
    private void generateTooltipForMarkets(final TooltipMakerAPI info, final Stage stageId) {
        boolean generated = false;
        for (AoTDExpeditionData aoTDExpeditionData : this.dataOfExpeditions.get(stageId)) {
            if (aoTDExpeditionData.target.isPlayerOwned()) {
                info.addPara("    - " + aoTDExpeditionData.target.getName(), Misc.getTooltipTitleAndLightHighlightColor(), 5.0f);
                aoTDExpeditionData.generateTooltipForStage(info, this.rebellingAgainst);
                generated = true;
            }
        }
        if (!generated) {
            info.addPara("All markets are currently safe!", Misc.getPositiveHighlightColor(), 5.0f);
        }
    }
    
    public void increaseAmountOfDefeatedFleets(final int amount) {
        this.fleetsDefeatedSince += amount;
    }
    
    public Stage getStage(final Object stage) {
        return (Stage)stage;
    }
    
    public void setUp() {
        this.maxProgress = 250;
        this.addStage((Object)Stage.START, 0);
        this.addStage((Object)Stage.THRESHOLD_1, 10);
        this.addStage((Object)Stage.THRESHOLD_2, 90);
        this.addStage((Object)Stage.THRESHOLD_3, 170);
        this.addFactor((EventFactor)new HoldoutEventFactor());
    }
    
    public int getPointsToReachNearThreshold() {
        final int curr = this.progress;
        if (curr >= this.getDataFor((Object)Stage.THRESHOLD_1).progress && curr < this.getDataFor((Object)Stage.THRESHOLD_2).progress) {
            return this.getDataFor((Object)Stage.THRESHOLD_2).progress;
        }
        if (curr >= this.getDataFor((Object)Stage.THRESHOLD_2).progress && curr < this.getDataFor((Object)Stage.THRESHOLD_3).progress) {
            return this.getDataFor((Object)Stage.THRESHOLD_3).progress;
        }
        return 0;
    }
    
    protected void notifyEnding() {
        super.notifyEnding();
        Global.getSector().getListenerManager().removeListener((Object)this);
    }
    
    protected void notifyEnded() {
        super.notifyEnded();
        Global.getSector().getMemoryWithoutUpdate().unset(AoTDSecessionManager.memFlag);
    }
    
    public void reportFleetDespawnedToListener(final CampaignFleetAPI fleet, final CampaignEventListener.FleetDespawnReason reason, final Object param) {
    }
    
    protected void advanceImpl(final float amount) {
        super.advanceImpl(amount);
        if (Global.getSettings().getModManager().isModEnabled("nexerlin")) {
            final DiplomacyBrain brain = DiplomacyManager.getManager().getDiplomacyBrain(this.rebellingAgainst.getId());
            brain.getRecentWars().put("player", 120.0f);
        }
        this.rebellingAgainst.getRelToPlayer().setLevel(RepLevel.VENGEFUL);
        if (Misc.getFactionMarkets(this.rebellingAgainst).isEmpty()) {
            this.endRebellion(true);
            return;
        }
        if (Misc.getPlayerMarkets(false).isEmpty()) {
            this.endRebellion(false);
            return;
        }
        if (this.getLastActiveStage(true).id == Stage.THRESHOLD_3) {
            boolean defeatedAll = true;
            for (final AoTDExpeditionData aoTDExpeditionData : this.dataOfExpeditions.get(Stage.THRESHOLD_3)) {
                if (aoTDExpeditionData.intel.getOutcome() == null) {
                    this.setProgress(195);
                    defeatedAll = false;
                    break;
                }
            }
            if (defeatedAll) {
                this.endRebellion(true);
            }
        }
    }
    
    public void makeSuspicius(final FactionAPI other, final InteractionDialogAPI dialog) {
        final ReputationActionResponsePlugin.ReputationAdjustmentResult rep = Global.getSector().adjustPlayerReputation((Object)new CoreReputationPlugin.RepActionEnvelope(CoreReputationPlugin.RepActions.MAKE_SUSPICOUS_AT_WORST, (Object)null, (CommMessageAPI)null, (dialog != null) ? dialog.getTextPanel() : null, false, true), other.getId());
        final FactionCommissionIntel.RepChangeData data = new FactionCommissionIntel.RepChangeData();
        data.faction = other;
        data.delta = rep.delta;
    }
    
    public int getMaxMonthlyProgress() {
        if (this.getLastActiveStage(true).id == Stage.THRESHOLD_3) {
            for (final AoTDExpeditionData aoTDExpeditionData : this.dataOfExpeditions.get(Stage.THRESHOLD_3)) {
                if (aoTDExpeditionData.intel.getOutcome() == null) {
                    this.setProgress(195);
                    return 0;
                }
            }
        }
        return super.getMaxMonthlyProgress();
    }
    
    public void endRebellion(final boolean success) {
        for (final ArrayList<AoTDExpeditionData> value : this.dataOfExpeditions.values()) {
            for (final AoTDExpeditionData aoTDExpeditionData : value) {
                aoTDExpeditionData.intel = null;
            }
            value.clear();
        }
        this.dataOfExpeditions.clear();
        if (success) {
            this.makeSuspicius(this.rebellingAgainst, null);
            Global.getSector().getMemory().set(EmergentAuthorityApplier.memKey, (Object)true);
        }
        this.marketsCaptured.clear();
        this.originalMarkets.clear();
        this.endImmediately();
    }
    
    public void reportBattleOccurred(final CampaignFleetAPI fleet, final CampaignFleetAPI primaryWinner, final BattleAPI battle) {
    }
    
    protected String getStageIconImpl(final Object stageId) {
        final BaseEventIntel.EventStageData esd = this.getDataFor(stageId);
        if (esd == null) {
            return null;
        }
        if (esd.id != Stage.START) {
            return Global.getSettings().getSpriteName("events", "hostile_activity_HA_" + (((Stage)esd.id).ordinal() + 1));
        }
        return Global.getSettings().getSpriteName("events", "hostile_activity_HA_1");
    }
    
    public String getIcon() {
        return Global.getSettings().getSpriteName("events", "hostile_activity_HA_5");
    }
    
    protected String getName() {
        return "Independence war";
    }
    
    public void createLargeDescription(final CustomPanelAPI panel, final float width, final float height) {
        final float opad = 10.0f;
        this.uiWidth = width;
        final TooltipMakerAPI main = panel.createUIElement(width, height, true);
        main.setTitleOrbitronVeryLarge();
        main.addTitle(this.getName(), Misc.getBasePlayerColor());
        final EventProgressBarAPI bar = main.addEventProgressBar((BaseEventIntel)this, 100.0f);
        final TooltipMakerAPI.TooltipCreator barTC = this.getBarTooltip();
        if (barTC != null) {
            main.addTooltipToPrevious(barTC, TooltipMakerAPI.TooltipLocation.BELOW, false);
        }
        for (final BaseEventIntel.EventStageData curr : this.stages) {
            if (curr.progress <= 0) {
                continue;
            }
            if ("random_event_none".equals(curr.rollData)) {
                continue;
            }
            if (curr.wasEverReached && curr.isOneOffEvent && !curr.isRepeatable) {
                continue;
            }
            if (curr.hideIconWhenPastStageUnlessLastActive && curr.progress <= this.progress && this.getLastActiveStage(true) != curr) {
                continue;
            }
            final BaseEventIntel.EventStageDisplayData data = this.createDisplayData(curr.id);
            final UIComponentAPI marker = main.addEventStageMarker(data);
            final float xOff = bar.getXCoordinateForProgress((float)curr.progress) - bar.getPosition().getX();
            marker.getPosition().aboveLeft((UIComponentAPI)bar, data.downLineLength).setXAlignOffset(xOff - data.size / 2.0f - 1.0f);
            final TooltipMakerAPI.TooltipCreator tc = this.getStageTooltip(curr.id);
            if (tc == null) {
                continue;
            }
            main.addTooltipTo(tc, marker, TooltipMakerAPI.TooltipLocation.LEFT, false);
        }
        final UIComponentAPI marker2 = main.addEventProgressMarker((BaseEventIntel)this);
        final float xOff2 = bar.getXCoordinateForProgress((float)this.progress) - bar.getPosition().getX();
        marker2.getPosition().belowLeft((UIComponentAPI)bar, -this.getBarProgressIndicatorHeight() * 0.5f - 2.0f).setXAlignOffset(xOff2 - this.getBarProgressIndicatorWidth() / 2.0f - 1.0f);
        final float barW = this.getBarWidth();
        main.addSpacer(opad);
        main.addSpacer(opad);
        final TooltipMakerAPI tp = main.beginSubTooltip(barW);
        tp.addSectionHeading("Rebellion", Alignment.MID, 0.0f);
        tp.addPara("We have started a righteous rebellion to break free from the shackles %s imposed on us!", 5.0f, Color.ORANGE, new String[] { this.rebellingAgainst.getDisplayNameLongWithArticle() });
        tp.addPara("To succeed, we must tire them out and repel their final assault. ", 5.0f, Color.ORANGE, new String[] { "" + this.getMaxProgress() });
        tp.addSectionHeading("Earning points", Alignment.MID, 5.0f);
        tp.addPara("    - Hold our ground", Misc.getTooltipTitleAndLightHighlightColor(), 5.0f);
        tp.addPara("      Time is on our side. The longer we hold as many world as possible, the quicker %s 's loyalists dissolve, the more legitimate our rebellion becomes.", 3.0f, Color.ORANGE, new String[] { this.rebellingAgainst.getDisplayNameLong() });
        if (Global.getSettings().getModManager().isModEnabled("nexerelin")) {
            tp.addPara("    - Conquer their worlds", Misc.getTooltipTitleAndLightHighlightColor(), 5.0f);
            tp.addPara("      Managing to take even one of loyalists world will significantly increase our effort of gaining independence.", 3.0f);
        }
        main.endSubTooltip();
        main.addCustom((UIComponentAPI)tp, 5.0f);
        main.addSpacer(opad);
        if (this.getLastActiveStage(true) != null) {
            this.addStageDescriptionWithImage(main, this.getLastActiveStage(true).id);
        }
        float factorWidth = (barW - opad) / 2.0f;
        if (this.withMonthlyFactors() != this.withOneTimeFactors()) {
            factorWidth = (float)(int)(barW * 0.6f);
        }
        final TooltipMakerAPI mFac = main.beginSubTooltip(factorWidth);
        final Color c = this.getFactionForUIColors().getBaseUIColor();
        final Color bg = this.getFactionForUIColors().getDarkUIColor();
        mFac.addSectionHeading("Monthly factors", c, bg, Alignment.MID, opad).getPosition().setXAlignOffset(0.0f);
        final float strW = 40.0f;
        final float rh = 20.0f;
        mFac.beginTable2(this.getFactionForUIColors(), rh, false, false, new Object[] { "Monthly factors", factorWidth - strW - 3.0f, "Progress", strW });
        for (final EventFactor factor : this.factors) {
            if (factor.isOneTime()) {
                continue;
            }
            if (!factor.shouldShow((BaseEventIntel)this)) {
                continue;
            }
            final String desc = factor.getDesc((BaseEventIntel)this);
            if (desc != null) {
                mFac.addRowWithGlow(new Object[] { Alignment.LMID, factor.getDescColor((BaseEventIntel)this), desc, Alignment.RMID, factor.getProgressColor((BaseEventIntel)this), factor.getProgressStr((BaseEventIntel)this) });
                final TooltipMakerAPI.TooltipCreator t = factor.getMainRowTooltip((BaseEventIntel)this);
                if (t != null) {
                    mFac.addTooltipToAddedRow(t, TooltipMakerAPI.TooltipLocation.RIGHT, false);
                }
            }
            factor.addExtraRows(mFac, (BaseEventIntel)this);
        }
        mFac.addTable("None", -1, opad);
        mFac.getPrev().getPosition().setXAlignOffset(-5.0f);
        main.endSubTooltip();
        final TooltipMakerAPI oFac = main.beginSubTooltip(factorWidth);
        oFac.addSectionHeading("Recent one-time factors", c, bg, Alignment.MID, opad).getPosition().setXAlignOffset(0.0f);
        oFac.beginTable2(this.getFactionForUIColors(), 20.0f, false, false, new Object[] { "One-time factors", factorWidth - strW - 3.0f, "Progress", strW });
        final List<EventFactor> reversed = new ArrayList<EventFactor>(this.factors);
        Collections.reverse(reversed);
        for (final EventFactor factor2 : reversed) {
            if (!factor2.isOneTime()) {
                continue;
            }
            if (!factor2.shouldShow((BaseEventIntel)this)) {
                continue;
            }
            final String desc2 = factor2.getDesc((BaseEventIntel)this);
            if (desc2 != null) {
                oFac.addRowWithGlow(new Object[] { Alignment.LMID, factor2.getDescColor((BaseEventIntel)this), desc2, Alignment.RMID, factor2.getProgressColor((BaseEventIntel)this), factor2.getProgressStr((BaseEventIntel)this) });
                final TooltipMakerAPI.TooltipCreator t2 = factor2.getMainRowTooltip((BaseEventIntel)this);
                if (t2 != null) {
                    oFac.addTooltipToAddedRow(t2, TooltipMakerAPI.TooltipLocation.LEFT);
                }
            }
            factor2.addExtraRows(oFac, (BaseEventIntel)this);
        }
        oFac.addTable("None", -1, opad);
        oFac.getPrev().getPosition().setXAlignOffset(-5.0f);
        main.endSubTooltip();
        final float factorHeight = Math.max(mFac.getHeightSoFar(), oFac.getHeightSoFar());
        mFac.setHeightSoFar(factorHeight);
        oFac.setHeightSoFar(factorHeight);
        if (this.withMonthlyFactors() && this.withOneTimeFactors()) {
            main.addCustom((UIComponentAPI)mFac, opad * 2.0f);
            main.addCustomDoNotSetPosition((UIComponentAPI)oFac).getPosition().rightOfTop((UIComponentAPI)mFac, opad);
        }
        else if (this.withMonthlyFactors()) {
            main.addCustom((UIComponentAPI)mFac, opad * 2.0f);
        }
        else if (this.withOneTimeFactors()) {
            main.addCustom((UIComponentAPI)oFac, opad * 2.0f);
        }
        panel.addUIElement(main).inTL(0.0f, 0.0f);
    }
    
    static {
        AoTDSecessionManager.memFlag = "$aotd_secession";
    }
    
    public class AoTDExpeditionData
    {
        public MarketAPI target;
        public AoTDSecessionFleetIntel intel;
        
        public AoTDExpeditionData(final MarketAPI market, final AoTDSecessionFleetIntel intel) {
            this.target = market;
            this.intel = intel;
        }
        
        public void generateTooltipForStage(final TooltipMakerAPI tooltip, final FactionAPI faction) {
            this.generateInfoFromOutcome(this.intel, tooltip, Misc.getTooltipTitleAndLightHighlightColor(), 3.0f, faction);
        }
        
        private void generateInfoFromOutcome(final AoTDSecessionFleetIntel intel, final TooltipMakerAPI info, final Color tc, final float initPad, final FactionAPI other) {
            if (intel.getOutcome() == null) {
                if (intel.getGoal() == AoTDSecessionGoal.BOMBARD) {
                    info.addPara("            Under threat of saturation bombardment!", Misc.getNegativeHighlightColor(), 3.0f);
                }
                else {
                    info.addPara("            Under threat of invasion!", Misc.getNegativeHighlightColor(), 3.0f);
                }
            }
            else {
                info.addPara("            Defended !", Misc.getPositiveHighlightColor(), 3.0f);
            }
        }
    }
    
    public enum AoTDSecessionGoal
    {
        BOMBARD, 
        RETAKE;
    }
    
    public enum Stage
    {
        START, 
        THRESHOLD_1, 
        THRESHOLD_2, 
        THRESHOLD_3;
    }
    
    public static class AoTDSecessionReason
    {
        public AoTDSecessionGoal type;
        public String marketId;
        public float weight;
        
        public AoTDSecessionReason(final AoTDSecessionGoal type) {
            this.type = type;
        }
    }
}
